// Copyright 2016 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

// Make sure printing different element kinds doesn't crash.

var array;
var obj = {};

array = [];
v8DebugPrint(array);

// FAST_SMI_ELEMENTS
array = [1, 2, 3];
v8DebugPrint(array);

// FAST_HOLEY_SMI_ELEMENTS
array[10] = 100;
array[11] = 100;
v8DebugPrint(array);

// FAST_ELEMENTS
array = [1, obj, obj];
v8DebugPrint(array);

// FAST_HOLEY_ELEMENTS
array[100] = obj;
array[101] = obj;
v8DebugPrint(array);

// FAST_DOUBLE_ELEMENTS
array = [1.1, 2.2, 3.3, 3.3, 3.3, NaN];
v8DebugPrint(array);
array.push(NaN);
array.push(NaN);
v8DebugPrint(array);

// FAST_HOLEY_DOUBLE_ELEMENTS
array[100] = 1.2;
array[101] = 1.2;
v8DebugPrint(array);

// DICTIONARY_ELEMENTS
v8NormalizeElements(array);
v8DebugPrint(array);
