// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals("1", v8ToString(1));
assertEquals("1", v8ToString(1));

assertEquals("0.5", v8ToString(.5));
assertEquals("0.5", v8ToString(.5));

assertEquals("null", v8ToString(null));
assertEquals("null", v8ToString(null));

assertEquals("true", v8ToString(true));
assertEquals("true", v8ToString(true));

assertEquals("false", v8ToString(false));
assertEquals("false", v8ToString(false));

assertEquals("undefined", v8ToString(undefined));
assertEquals("undefined", v8ToString(undefined));

assertEquals("random text", v8ToString("random text"));
assertEquals("random text", v8ToString("random text"));

assertThrows(function() { v8ToString(Symbol.toPrimitive) }, TypeError);
assertThrows(function() { v8ToString(Symbol.toPrimitive) }, TypeError);

var a = { toString: function() { return "xyz" }};
assertEquals("xyz", v8ToString(a));
assertEquals("xyz", v8ToString(a));

var b = { valueOf: function() { return 42 }};
assertEquals("[object Object]", v8ToString(b));
assertEquals("[object Object]", v8ToString(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals("x", v8ToString(c));
assertEquals("x", v8ToString(c));

var d = {
  [Symbol.toPrimitive]: function(hint) { return hint }
};
assertEquals("string", v8ToString(d));
assertEquals("string", v8ToString(d));

var e = new Date(0);
assertEquals(e.toString(), v8ToString(e));
assertEquals(e.toString(), v8ToString(e));
